# Copyright 2022 InstaDeep Ltd. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from typing import TypeVar

import jax
import jax.numpy as jnp

T = TypeVar("T")


def first_from_device(tree: T) -> T:
    squeeze_fn = lambda x: x[0] if isinstance(x, jnp.ndarray) else x
    return jax.tree_util.tree_map(squeeze_fn, tree)  # type: ignore
